package sun.misc;

import java.io.IOException;
import java.io.OutputStream;

public class BASE64Encoder extends CharacterEncoder
{
    private static final char[] pem_array;
    
    public BASE64Encoder() {
    }
    
    @Override
    protected int bytesPerAtom() {
        return 3;
    }
    
    @Override
    protected int bytesPerLine() {
        return 57;
    }
    
    @Override
    protected void encodeAtom(OutputStream outputStream, byte[] array, int n, int n2) throws IOException {
        if (n2 == 1) {
            int n9 = array[n];
            int n10 = 0;
            outputStream.write((int)BASE64Encoder.pem_array[n9 >>> 2 & 0x3F]);
            outputStream.write((int)BASE64Encoder.pem_array[(n9 << 4 & 0x30) + (n10 >>> 4 & 0xF)]);
            outputStream.write(61);
            outputStream.write(61);
        }
        else if (n2 == 2) {
            int n6 = array[n];
            int n7 = array[n + 1];
            int n8 = 0;
            outputStream.write((int)BASE64Encoder.pem_array[n6 >>> 2 & 0x3F]);
            outputStream.write((int)BASE64Encoder.pem_array[(n6 << 4 & 0x30) + (n7 >>> 4 & 0xF)]);
            outputStream.write((int)BASE64Encoder.pem_array[(n7 << 2 & 0x3C) + (n8 >>> 6 & 0x3)]);
            outputStream.write(61);
        }
        else {
            int n3 = array[n];
            int n4 = array[n + 1];
            int n5 = array[n + 2];
            outputStream.write((int)BASE64Encoder.pem_array[n3 >>> 2 & 0x3F]);
            outputStream.write((int)BASE64Encoder.pem_array[(n3 << 4 & 0x30) + (n4 >>> 4 & 0xF)]);
            outputStream.write((int)BASE64Encoder.pem_array[(n4 << 2 & 0x3C) + (n5 >>> 6 & 0x3)]);
            outputStream.write((int)BASE64Encoder.pem_array[n5 & 0x3F]);
        }
    }
    
    static {
        pem_array = new char[] { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/' };
    }
}
